diff --git a/compiler/deSugar/DsCCall.lhs b/compiler/deSugar/DsCCall.lhs
index ed8a8f0..b308b7e 100644
--- a/compiler/deSugar/DsCCall.lhs
+++ b/compiler/deSugar/DsCCall.lhs
@@ -6,20 +6,14 @@
 Desugaring foreign calls
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module DsCCall 
-	( dsCCall
-	, mkFCall
-	, unboxArg
-	, boxResult
-	, resultWrapper
-	) where
+        ( dsCCall
+        , mkFCall
+        , unboxArg
+        , boxResult
+        , resultWrapper
+        ) where
 
 #include "HsVersions.h"
 
@@ -84,15 +78,15 @@ follows:
    |
    V
    \ s# -> case (ccall# foo [ r, t1#, ... tm# ] s# e1# ... em#) of
-	  (StateAnd<r># result# state#) -> (R# result#, realWorld#)
+          (StateAnd<r># result# state#) -> (R# result#, realWorld#)
 \end{verbatim}
 
 \begin{code}
-dsCCall :: CLabelString	-- C routine to invoke
-	-> [CoreExpr]	-- Arguments (desugared)
-	-> Safety	-- Safety of the call
-	-> Type		-- Type of the result: IO t
-	-> DsM CoreExpr	-- Result, of type ???
+dsCCall :: CLabelString -- C routine to invoke
+        -> [CoreExpr]   -- Arguments (desugared)
+        -> Safety       -- Safety of the call
+        -> Type         -- Type of the result: IO t
+        -> DsM CoreExpr -- Result, of type ???
 
 dsCCall lbl args may_gc result_ty
   = do (unboxed_args, arg_wrappers) <- mapAndUnzipM unboxArg args
@@ -106,35 +100,35 @@ dsCCall lbl args may_gc result_ty
        return (foldr ($) (res_wrapper the_prim_app) arg_wrappers)
 
 mkFCall :: DynFlags -> Unique -> ForeignCall 
-	-> [CoreExpr] 	-- Args
-	-> Type 	-- Result type
-	-> CoreExpr
+        -> [CoreExpr]   -- Args
+        -> Type         -- Result type
+        -> CoreExpr
 -- Construct the ccall.  The only tricky bit is that the ccall Id should have
 -- no free vars, so if any of the arg tys do we must give it a polymorphic type.
--- 	[I forget *why* it should have no free vars!]
+--      [I forget *why* it should have no free vars!]
 -- For example:
---	mkCCall ... [s::StablePtr (a->b), x::Addr, c::Char]
+--      mkCCall ... [s::StablePtr (a->b), x::Addr, c::Char]
 --
 -- Here we build a ccall thus
---	(ccallid::(forall a b.  StablePtr (a -> b) -> Addr -> Char -> IO Addr))
---			a b s x c
+--      (ccallid::(forall a b.  StablePtr (a -> b) -> Addr -> Char -> IO Addr))
+--                      a b s x c
 mkFCall dflags uniq the_fcall val_args res_ty
   = mkApps (mkVarApps (Var the_fcall_id) tyvars) val_args
   where
     arg_tys = map exprType val_args
     body_ty = (mkFunTys arg_tys res_ty)
     tyvars  = varSetElems (tyVarsOfType body_ty)
-    ty 	    = mkForAllTys tyvars body_ty
+    ty      = mkForAllTys tyvars body_ty
     the_fcall_id = mkFCallId dflags uniq the_fcall ty
 \end{code}
 
 \begin{code}
-unboxArg :: CoreExpr			-- The supplied argument
-	 -> DsM (CoreExpr,		-- To pass as the actual argument
-		 CoreExpr -> CoreExpr	-- Wrapper to unbox the arg
-		)
+unboxArg :: CoreExpr                    -- The supplied argument
+         -> DsM (CoreExpr,              -- To pass as the actual argument
+                 CoreExpr -> CoreExpr   -- Wrapper to unbox the arg
+                )
 -- Example: if the arg is e::Int, unboxArg will return
---	(x#::Int#, \W. case x of I# x# -> W)
+--      (x#::Int#, \W. case x of I# x# -> W)
 -- where W is a CoreExpr that probably mentions x#
 
 unboxArg arg
@@ -173,8 +167,8 @@ unboxArg arg
 
   -- Byte-arrays, both mutable and otherwise; hack warning
   -- We're looking for values of type ByteArray, MutableByteArray
-  --	data ByteArray          ix = ByteArray        ix ix ByteArray#
-  --	data MutableByteArray s ix = MutableByteArray ix ix (MutableByteArray# s)
+  --    data ByteArray          ix = ByteArray        ix ix ByteArray#
+  --    data MutableByteArray s ix = MutableByteArray ix ix (MutableByteArray# s)
   | is_product_type &&
     data_con_arity == 3 &&
     maybeToBool maybe_arg3_tycon &&
@@ -190,73 +184,73 @@ unboxArg arg
   = do l <- getSrcSpanDs
        pprPanic "unboxArg: " (ppr l <+> ppr arg_ty)
   where
-    arg_ty					= exprType arg
-    maybe_product_type 			   	= splitDataProductType_maybe arg_ty
-    is_product_type			   	= maybeToBool maybe_product_type
-    Just (_, _, data_con, data_con_arg_tys)	= maybe_product_type
-    data_con_arity				= dataConSourceArity data_con
-    (data_con_arg_ty1 : _)			= data_con_arg_tys
+    arg_ty                                      = exprType arg
+    maybe_product_type                          = splitDataProductType_maybe arg_ty
+    is_product_type                             = maybeToBool maybe_product_type
+    Just (_, _, data_con, data_con_arg_tys)     = maybe_product_type
+    data_con_arity                              = dataConSourceArity data_con
+    (data_con_arg_ty1 : _)                      = data_con_arg_tys
 
     (_ : _ : data_con_arg_ty3 : _) = data_con_arg_tys
-    maybe_arg3_tycon    	   = tyConAppTyCon_maybe data_con_arg_ty3
-    Just arg3_tycon		   = maybe_arg3_tycon
+    maybe_arg3_tycon               = tyConAppTyCon_maybe data_con_arg_ty3
+    Just arg3_tycon                = maybe_arg3_tycon
 \end{code}
 
 
 \begin{code}
 boxResult :: Type
-	  -> DsM (Type, CoreExpr -> CoreExpr)
+          -> DsM (Type, CoreExpr -> CoreExpr)
 
 -- Takes the result of the user-level ccall: 
---	either (IO t), 
---	or maybe just t for an side-effect-free call
+--      either (IO t), 
+--      or maybe just t for an side-effect-free call
 -- Returns a wrapper for the primitive ccall itself, along with the
 -- type of the result of the primitive ccall.  This result type
 -- will be of the form  
---	State# RealWorld -> (# State# RealWorld, t' #)
+--      State# RealWorld -> (# State# RealWorld, t' #)
 -- where t' is the unwrapped form of t.  If t is simply (), then
 -- the result type will be 
---	State# RealWorld -> (# State# RealWorld #)
+--      State# RealWorld -> (# State# RealWorld #)
 
 boxResult result_ty
   | Just (io_tycon, io_res_ty) <- tcSplitIOType_maybe result_ty
-	-- isIOType_maybe handles the case where the type is a 
-	-- simple wrapping of IO.  E.g.
-	-- 	newtype Wrap a = W (IO a)
-	-- No coercion necessary because its a non-recursive newtype
-	-- (If we wanted to handle a *recursive* newtype too, we'd need
-	-- another case, and a coercion.)
-   	-- The result is IO t, so wrap the result in an IO constructor
-  = do	{ res <- resultWrapper io_res_ty
-	; let extra_result_tys 
-		= case res of
-		     (Just ty,_) 
-		       | isUnboxedTupleType ty 
-		       -> let Just ls = tyConAppArgs_maybe ty in tail ls
-		     _ -> []
-
-	      return_result state anss
-		= mkConApp (tupleCon UnboxedTuple (2 + length extra_result_tys))
-	         	   (map Type (realWorldStatePrimTy : io_res_ty : extra_result_tys)
-			      ++ (state : anss)) 
-
-	; (ccall_res_ty, the_alt) <- mk_alt return_result res
-
-	; state_id <- newSysLocalDs realWorldStatePrimTy
-	; let io_data_con = head (tyConDataCons io_tycon)
-	      toIOCon     = dataConWrapId io_data_con
-
-	      wrap the_call =
-			      mkApps (Var toIOCon)
-			    	     [ Type io_res_ty, 
-			    	       Lam state_id $
-			    	       mkWildCase (App the_call (Var state_id))
-			    	     	     ccall_res_ty
-			                     (coreAltType the_alt) 
-			    	     	     [the_alt]
-			    	     ]
-
-	; return (realWorldStatePrimTy `mkFunTy` ccall_res_ty, wrap) }
+        -- isIOType_maybe handles the case where the type is a 
+        -- simple wrapping of IO.  E.g.
+        --      newtype Wrap a = W (IO a)
+        -- No coercion necessary because its a non-recursive newtype
+        -- (If we wanted to handle a *recursive* newtype too, we'd need
+        -- another case, and a coercion.)
+        -- The result is IO t, so wrap the result in an IO constructor
+  = do  { res <- resultWrapper io_res_ty
+        ; let extra_result_tys 
+                = case res of
+                     (Just ty,_) 
+                       | isUnboxedTupleType ty 
+                       -> let Just ls = tyConAppArgs_maybe ty in tail ls
+                     _ -> []
+
+              return_result state anss
+                = mkConApp (tupleCon UnboxedTuple (2 + length extra_result_tys))
+                           (map Type (realWorldStatePrimTy : io_res_ty : extra_result_tys)
+                              ++ (state : anss)) 
+
+        ; (ccall_res_ty, the_alt) <- mk_alt return_result res
+
+        ; state_id <- newSysLocalDs realWorldStatePrimTy
+        ; let io_data_con = head (tyConDataCons io_tycon)
+              toIOCon     = dataConWrapId io_data_con
+
+              wrap the_call =
+                              mkApps (Var toIOCon)
+                                     [ Type io_res_ty, 
+                                       Lam state_id $
+                                       mkWildCase (App the_call (Var state_id))
+                                             ccall_res_ty
+                                             (coreAltType the_alt) 
+                                             [the_alt]
+                                     ]
+
+        ; return (realWorldStatePrimTy `mkFunTy` ccall_res_ty, wrap) }
 
 boxResult result_ty
   = do -- It isn't IO, so do unsafePerformIO
@@ -265,9 +259,9 @@ boxResult result_ty
        (ccall_res_ty, the_alt) <- mk_alt return_result res
        let
            wrap = \ the_call -> mkWildCase (App the_call (Var realWorldPrimId)) 
-                                     	   ccall_res_ty
-                                     	   (coreAltType the_alt)
-                                     	   [the_alt]
+                                           ccall_res_ty
+                                           (coreAltType the_alt)
+                                           [the_alt]
        return (realWorldStatePrimTy `mkFunTy` ccall_res_ty, wrap)
   where
     return_result _ [ans] = ans
@@ -290,7 +284,7 @@ mk_alt return_result (Nothing, wrap_result)
        return (ccall_res_ty, the_alt)
 
 mk_alt return_result (Just prim_res_ty, wrap_result)
-    		-- The ccall returns a non-() value
+                -- The ccall returns a non-() value
   | isUnboxedTupleType prim_res_ty= do
     let
         Just ls = tyConAppArgs_maybe prim_res_ty
@@ -383,11 +377,11 @@ maybeNarrow dflags tycon
   | tycon `hasKey` int8TyConKey   = \e -> App (Var (mkPrimOpId Narrow8IntOp)) e
   | tycon `hasKey` int16TyConKey  = \e -> App (Var (mkPrimOpId Narrow16IntOp)) e
   | tycon `hasKey` int32TyConKey
-	 && wORD_SIZE dflags > 4         = \e -> App (Var (mkPrimOpId Narrow32IntOp)) e
+         && wORD_SIZE dflags > 4         = \e -> App (Var (mkPrimOpId Narrow32IntOp)) e
 
   | tycon `hasKey` word8TyConKey  = \e -> App (Var (mkPrimOpId Narrow8WordOp)) e
   | tycon `hasKey` word16TyConKey = \e -> App (Var (mkPrimOpId Narrow16WordOp)) e
   | tycon `hasKey` word32TyConKey
-	 && wORD_SIZE dflags > 4         = \e -> App (Var (mkPrimOpId Narrow32WordOp)) e
-  | otherwise			  = id
+         && wORD_SIZE dflags > 4         = \e -> App (Var (mkPrimOpId Narrow32WordOp)) e
+  | otherwise                     = id
 \end{code}
diff --git a/compiler/deSugar/DsUtils.lhs b/compiler/deSugar/DsUtils.lhs
index 420cc0f..feaeaee 100644
--- a/compiler/deSugar/DsUtils.lhs
+++ b/compiler/deSugar/DsUtils.lhs
@@ -8,28 +8,22 @@ Utilities for desugaring
 This module exports some utility functions of no great interest.
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 -- | Utility functions for constructing Core syntax, principally for desugaring
 module DsUtils (
-	EquationInfo(..), 
-	firstPat, shiftEqns,
+        EquationInfo(..), 
+        firstPat, shiftEqns,
 
-	MatchResult(..), CanItFail(..), 
-	cantFailMatchResult, alwaysFailMatchResult,
-	extractMatchResult, combineMatchResults, 
-	adjustMatchResult,  adjustMatchResultDs,
-	mkCoLetMatchResult, mkViewMatchResult, mkGuardedMatchResult, 
-	matchCanFail, mkEvalMatchResult,
-	mkCoPrimCaseMatchResult, mkCoAlgCaseMatchResult,
-	wrapBind, wrapBinds,
+        MatchResult(..), CanItFail(..), 
+        cantFailMatchResult, alwaysFailMatchResult,
+        extractMatchResult, combineMatchResults, 
+        adjustMatchResult,  adjustMatchResultDs,
+        mkCoLetMatchResult, mkViewMatchResult, mkGuardedMatchResult, 
+        matchCanFail, mkEvalMatchResult,
+        mkCoPrimCaseMatchResult, mkCoAlgCaseMatchResult,
+        wrapBind, wrapBinds,
 
-	mkErrorAppDs, mkCoreAppDs, mkCoreAppsDs,
+        mkErrorAppDs, mkCoreAppDs, mkCoreAppsDs,
 
         seqVar,
 
@@ -39,13 +33,13 @@ module DsUtils (
 
         mkSelectorBinds,
 
-	selectSimpleMatchVarL, selectMatchVars, selectMatchVar,
+        selectSimpleMatchVarL, selectMatchVars, selectMatchVar,
         mkOptTickBox, mkBinaryTickBox
     ) where
 
 #include "HsVersions.h"
 
-import {-# SOURCE #-}	Match ( matchSimply )
+import {-# SOURCE #-}   Match ( matchSimply )
 
 import HsSyn
 import TcHsSyn
@@ -80,9 +74,9 @@ import Control.Monad    ( zipWithM )
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{ Selecting match variables}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 We're about to match against some patterns.  We want to make some
@@ -100,13 +94,13 @@ selectSimpleMatchVarL pat = selectMatchVar (unLoc pat)
 --
 -- OLD, but interesting note:
 --    But even if it is a variable, its type might not match.  Consider
---	data T a where
---	  T1 :: Int -> T Int
---	  T2 :: a   -> T a
+--      data T a where
+--        T1 :: Int -> T Int
+--        T2 :: a   -> T a
 --
---	f :: T a -> a -> Int
---	f (T1 i) (x::Int) = x
---	f (T2 i) (y::a)   = 0
+--      f :: T a -> a -> Int
+--      f (T1 i) (x::Int) = x
+--      f (T2 i) (y::a)   = 0
 --    Then we must not choose (x::Int) as the matching variable!
 -- And nowadays we won't, because the (x::Int) will be wrapped in a CoPat
 
@@ -120,7 +114,7 @@ selectMatchVar (ParPat pat)  = selectMatchVar (unLoc pat)
 selectMatchVar (VarPat var)  = return (localiseId var)  -- Note [Localise pattern binders]
 selectMatchVar (AsPat var _) = return (unLoc var)
 selectMatchVar other_pat     = newSysLocalDs (hsPatType other_pat)
-				  -- OK, better make up one...
+                                  -- OK, better make up one...
 \end{code}
 
 Note [Localise pattern binders]
@@ -162,9 +156,9 @@ the desugaring pass.
 
 
 %************************************************************************
-%*									*
-%* type synonym EquationInfo and access functions for its pieces	*
-%*									*
+%*                                                                      *
+%* type synonym EquationInfo and access functions for its pieces        *
+%*                                                                      *
 %************************************************************************
 \subsection[EquationInfo-synonym]{@EquationInfo@: a useful synonym}
 
@@ -229,13 +223,13 @@ wrapBinds [] e = e
 wrapBinds ((new,old):prs) e = wrapBind new old (wrapBinds prs e)
 
 wrapBind :: Var -> Var -> CoreExpr -> CoreExpr
-wrapBind new old body	-- NB: this function must deal with term
-  | new==old    = body	-- variables, type variables or coercion variables
+wrapBind new old body   -- NB: this function must deal with term
+  | new==old    = body  -- variables, type variables or coercion variables
   | otherwise   = Let (NonRec new (varToCoreExpr old)) body
 
 seqVar :: Var -> CoreExpr -> CoreExpr
 seqVar var body = Case (Var var) var (exprType body)
-			[(DEFAULT, [], body)]
+                        [(DEFAULT, [], body)]
 
 mkCoLetMatchResult :: CoreBind -> MatchResult -> MatchResult
 mkCoLetMatchResult bind = adjustMatchResult (mkCoreLet bind)
@@ -255,10 +249,10 @@ mkGuardedMatchResult pred_expr (MatchResult _ body_fn)
   = MatchResult CanFail (\fail -> do body <- body_fn fail
                                      return (mkIfThenElse pred_expr body fail))
 
-mkCoPrimCaseMatchResult :: Id				-- Scrutinee
+mkCoPrimCaseMatchResult :: Id                           -- Scrutinee
                     -> Type                             -- Type of the case
-		    -> [(Literal, MatchResult)]		-- Alternatives
-		    -> MatchResult			-- Literals are all unlifted
+                    -> [(Literal, MatchResult)]         -- Alternatives
+                    -> MatchResult                      -- Literals are all unlifted
 mkCoPrimCaseMatchResult var ty match_alts
   = MatchResult CanFail mk_case
   where
@@ -266,7 +260,7 @@ mkCoPrimCaseMatchResult var ty match_alts
         alts <- mapM (mk_alt fail) sorted_alts
         return (Case (Var var) var ty ((DEFAULT, [], fail) : alts))
 
-    sorted_alts = sortWith fst match_alts	-- Right order for a Case
+    sorted_alts = sortWith fst match_alts       -- Right order for a Case
     mk_alt fail (lit, MatchResult _ body_fn)
        = ASSERT( not (litIsLifted lit) )
          do body <- body_fn fail
@@ -275,41 +269,41 @@ mkCoPrimCaseMatchResult var ty match_alts
 
 mkCoAlgCaseMatchResult 
   :: DynFlags
-  -> Id					   -- Scrutinee
+  -> Id                                    -- Scrutinee
   -> Type                                  -- Type of exp
   -> [(DataCon, [CoreBndr], MatchResult)]  -- Alternatives (bndrs *include* tyvars, dicts)
   -> MatchResult
 mkCoAlgCaseMatchResult dflags var ty match_alts 
-  | isNewTyCon tycon		-- Newtype case; use a let
+  | isNewTyCon tycon            -- Newtype case; use a let
   = ASSERT( null (tail match_alts) && null (tail arg_ids1) )
     mkCoLetMatchResult (NonRec arg_id1 newtype_rhs) match_result1
 
-  | isPArrFakeAlts match_alts	-- Sugared parallel array; use a literal case 
+  | isPArrFakeAlts match_alts   -- Sugared parallel array; use a literal case 
   = MatchResult CanFail mk_parrCase
 
-  | otherwise			-- Datatype case; use a case
+  | otherwise                   -- Datatype case; use a case
   = MatchResult fail_flag mk_case
   where
     tycon = dataConTyCon con1
-	-- [Interesting: because of GADTs, we can't rely on the type of 
-	--  the scrutinised Id to be sufficiently refined to have a TyCon in it]
+        -- [Interesting: because of GADTs, we can't rely on the type of 
+        --  the scrutinised Id to be sufficiently refined to have a TyCon in it]
 
-	-- Stuff for newtype
+        -- Stuff for newtype
     (con1, arg_ids1, match_result1) = ASSERT( notNull match_alts ) head match_alts
-    arg_id1 	= ASSERT( notNull arg_ids1 ) head arg_ids1
+    arg_id1     = ASSERT( notNull arg_ids1 ) head arg_ids1
     var_ty      = idType var
-    (tc, ty_args) = tcSplitTyConApp var_ty	-- Don't look through newtypes
-    	 	    		    		-- (not that splitTyConApp does, these days)
+    (tc, ty_args) = tcSplitTyConApp var_ty      -- Don't look through newtypes
+                                                -- (not that splitTyConApp does, these days)
     newtype_rhs = unwrapNewTypeBody tc ty_args (Var var)
-		
-	-- Stuff for data types
+                
+        -- Stuff for data types
     data_cons      = tyConDataCons tycon
     match_results  = [match_result | (_,_,match_result) <- match_alts]
 
     fail_flag | exhaustive_case
-	      = foldr orFail CantFail [can_it_fail | MatchResult can_it_fail _ <- match_results]
-	      | otherwise
-	      = CanFail
+              = foldr orFail CantFail [can_it_fail | MatchResult can_it_fail _ <- match_results]
+              | otherwise
+              = CanFail
 
     sorted_alts  = sortWith get_tag match_alts
     get_tag (con, _, _) = dataConTag con
@@ -326,34 +320,34 @@ mkCoAlgCaseMatchResult dflags var ty match_alts
            ; return (DataAlt con, rep_ids, mkLets binds body) } } }
 
     mk_default fail | exhaustive_case = []
-		    | otherwise       = [(DEFAULT, [], fail)]
+                    | otherwise       = [(DEFAULT, [], fail)]
 
     un_mentioned_constructors
         = mkUniqSet data_cons `minusUniqSet` mkUniqSet [ con | (con, _, _) <- match_alts]
     exhaustive_case = isEmptyUniqSet un_mentioned_constructors
 
-	-- Stuff for parallel arrays
-	-- 
-	--  * the following is to desugar cases over fake constructors for
-	--   parallel arrays, which are introduced by `tidy1' in the `PArrPat'
-	--   case
-	--
-	-- Concerning `isPArrFakeAlts':
-	--
-	--  * it is *not* sufficient to just check the type of the type
-	--   constructor, as we have to be careful not to confuse the real
-	--   representation of parallel arrays with the fake constructors;
-	--   moreover, a list of alternatives must not mix fake and real
-	--   constructors (this is checked earlier on)
-	--
-	-- FIXME: We actually go through the whole list and make sure that
-	--	  either all or none of the constructors are fake parallel
-	--	  array constructors.  This is to spot equations that mix fake
-	--	  constructors with the real representation defined in
-	--	  `PrelPArr'.  It would be nicer to spot this situation
-	--	  earlier and raise a proper error message, but it can really
-	--	  only happen in `PrelPArr' anyway.
-	--
+        -- Stuff for parallel arrays
+        -- 
+        --  * the following is to desugar cases over fake constructors for
+        --   parallel arrays, which are introduced by `tidy1' in the `PArrPat'
+        --   case
+        --
+        -- Concerning `isPArrFakeAlts':
+        --
+        --  * it is *not* sufficient to just check the type of the type
+        --   constructor, as we have to be careful not to confuse the real
+        --   representation of parallel arrays with the fake constructors;
+        --   moreover, a list of alternatives must not mix fake and real
+        --   constructors (this is checked earlier on)
+        --
+        -- FIXME: We actually go through the whole list and make sure that
+        --        either all or none of the constructors are fake parallel
+        --        array constructors.  This is to spot equations that mix fake
+        --        constructors with the real representation defined in
+        --        `PrelPArr'.  It would be nicer to spot this situation
+        --        earlier and raise a proper error message, but it can really
+        --        only happen in `PrelPArr' anyway.
+        --
     isPArrFakeAlts [(dcon, _, _)]      = isPArrFakeCon dcon
     isPArrFakeAlts ((dcon, _, _):alts) = 
       case (isPArrFakeCon dcon, isPArrFakeAlts alts) of
@@ -367,47 +361,47 @@ mkCoAlgCaseMatchResult dflags var ty match_alts
       alt <- unboxAlt
       return (mkWildCase (len lengthP) intTy ty [alt])
       where
-	elemTy      = case splitTyConApp (idType var) of
-		        (_, [elemTy]) -> elemTy
-		        _	        -> panic panicMsg
+        elemTy      = case splitTyConApp (idType var) of
+                        (_, [elemTy]) -> elemTy
+                        _               -> panic panicMsg
         panicMsg    = "DsUtils.mkCoAlgCaseMatchResult: not a parallel array?"
-	len lengthP = mkApps (Var lengthP) [Type elemTy, Var var]
-	--
-	unboxAlt = do
-	  l      <- newSysLocalDs intPrimTy
-	  indexP <- dsDPHBuiltin indexPVar
-	  alts   <- mapM (mkAlt indexP) sorted_alts
-	  return (DataAlt intDataCon, [l], mkWildCase (Var l) intPrimTy ty (dft : alts))
+        len lengthP = mkApps (Var lengthP) [Type elemTy, Var var]
+        --
+        unboxAlt = do
+          l      <- newSysLocalDs intPrimTy
+          indexP <- dsDPHBuiltin indexPVar
+          alts   <- mapM (mkAlt indexP) sorted_alts
+          return (DataAlt intDataCon, [l], mkWildCase (Var l) intPrimTy ty (dft : alts))
+          where
+            dft  = (DEFAULT, [], fail)
+        --
+        -- each alternative matches one array length (corresponding to one
+        -- fake array constructor), so the match is on a literal; each
+        -- alternative's body is extended by a local binding for each
+        -- constructor argument, which are bound to array elements starting
+        -- with the first
+        --
+        mkAlt indexP (con, args, MatchResult _ bodyFun) = do
+          body <- bodyFun fail
+          return (LitAlt lit, [], mkCoreLets binds body)
           where
-	    dft  = (DEFAULT, [], fail)
-	--
-	-- each alternative matches one array length (corresponding to one
-	-- fake array constructor), so the match is on a literal; each
-	-- alternative's body is extended by a local binding for each
-	-- constructor argument, which are bound to array elements starting
-	-- with the first
-	--
-	mkAlt indexP (con, args, MatchResult _ bodyFun) = do
-	  body <- bodyFun fail
-	  return (LitAlt lit, [], mkCoreLets binds body)
-	  where
-	    lit   = MachInt $ toInteger (dataConSourceArity con)
-	    binds = [NonRec arg (indexExpr i) | (i, arg) <- zip [1..] args]
-	    --
-	    indexExpr i = mkApps (Var indexP) [Type elemTy, Var var, mkIntExpr dflags i]
+            lit   = MachInt $ toInteger (dataConSourceArity con)
+            binds = [NonRec arg (indexExpr i) | (i, arg) <- zip [1..] args]
+            --
+            indexExpr i = mkApps (Var indexP) [Type elemTy, Var var, mkIntExpr dflags i]
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Desugarer's versions of some Core functions}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
-mkErrorAppDs :: Id 		-- The error function
-	     -> Type		-- Type to which it should be applied
-	     -> SDoc		-- The error message string to pass
-	     -> DsM CoreExpr
+mkErrorAppDs :: Id              -- The error function
+             -> Type            -- Type to which it should be applied
+             -> SDoc            -- The error message string to pass
+             -> DsM CoreExpr
 
 mkErrorAppDs err_id ty msg = do
     src_loc <- getSrcSpanDs
@@ -495,7 +489,7 @@ mkCoreAppDs (Var f `App` Type ty1 `App` Type ty2 `App` arg1) arg2
                    Var v1 | isLocalId v1 -> v1        -- Note [Desugaring seq (2) and (3)]
                    _                     -> mkWildValBinder ty1
 
-mkCoreAppDs fun arg = mkCoreApp fun arg	 -- The rest is done in MkCore
+mkCoreAppDs fun arg = mkCoreApp fun arg  -- The rest is done in MkCore
 
 mkCoreAppsDs :: CoreExpr -> [CoreExpr] -> CoreExpr
 mkCoreAppsDs fun args = foldl mkCoreAppDs fun args
@@ -503,9 +497,9 @@ mkCoreAppsDs fun args = foldl mkCoreAppDs fun args
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[mkSelectorBind]{Make a selector bind}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 This is used in various places to do with lazy patterns.
@@ -553,8 +547,8 @@ cases like
 \begin{code}
 mkSelectorBinds :: [Maybe (Tickish Id)]  -- ticks to add, possibly
                 -> LPat Id      -- The pattern
-		-> CoreExpr	-- Expression to which the pattern is bound
-		-> DsM [(Id,CoreExpr)]
+                -> CoreExpr     -- Expression to which the pattern is bound
+                -> DsM [(Id,CoreExpr)]
 
 mkSelectorBinds ticks (L _ (VarPat v)) val_expr
   = return [(v, case ticks of
@@ -644,7 +638,7 @@ mkLHsPatTup :: [LPat Id] -> LPat Id
 mkLHsPatTup []     = noLoc $ mkVanillaTuplePat [] Boxed
 mkLHsPatTup [lpat] = lpat
 mkLHsPatTup lpats  = L (getLoc (head lpats)) $ 
-		     mkVanillaTuplePat lpats Boxed
+                     mkVanillaTuplePat lpats Boxed
 
 mkLHsVarPatTup :: [Id] -> LPat Id
 mkLHsVarPatTup bs  = mkLHsPatTup (map nlVarPat bs)
@@ -670,21 +664,21 @@ mkBigLHsPatTup = mkChunkified mkLHsPatTup
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[mkFailurePair]{Code for pattern-matching and other failures}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Generally, we handle pattern matching failure like this: let-bind a
 fail-variable, and use that variable if the thing fails:
 \begin{verbatim}
-	let fail.33 = error "Help"
-	in
-	case x of
-		p1 -> ...
-		p2 -> fail.33
-		p3 -> fail.33
-		p4 -> ...
+        let fail.33 = error "Help"
+        in
+        case x of
+                p1 -> ...
+                p2 -> fail.33
+                p3 -> fail.33
+                p4 -> ...
 \end{verbatim}
 Then
 \begin{itemize}
@@ -703,31 +697,31 @@ There's a problem when the result of the case expression is of
 unboxed type.  Then the type of @fail.33@ is unboxed too, and
 there is every chance that someone will change the let into a case:
 \begin{verbatim}
-	case error "Help" of
-	  fail.33 -> case ....
+        case error "Help" of
+          fail.33 -> case ....
 \end{verbatim}
 
 which is of course utterly wrong.  Rather than drop the condition that
 only boxed types can be let-bound, we just turn the fail into a function
 for the primitive case:
 \begin{verbatim}
-	let fail.33 :: Void -> Int#
-	    fail.33 = \_ -> error "Help"
-	in
-	case x of
-		p1 -> ...
-		p2 -> fail.33 void
-		p3 -> fail.33 void
-		p4 -> ...
+        let fail.33 :: Void -> Int#
+            fail.33 = \_ -> error "Help"
+        in
+        case x of
+                p1 -> ...
+                p2 -> fail.33 void
+                p3 -> fail.33 void
+                p4 -> ...
 \end{verbatim}
 
 Now @fail.33@ is a function, so it can be let-bound.
 
 \begin{code}
-mkFailurePair :: CoreExpr	-- Result type of the whole case expression
-	      -> DsM (CoreBind,	-- Binds the newly-created fail variable
-				-- to \ _ -> expression
-		      CoreExpr)	-- Fail variable applied to realWorld#
+mkFailurePair :: CoreExpr       -- Result type of the whole case expression
+              -> DsM (CoreBind, -- Binds the newly-created fail variable
+                                -- to \ _ -> expression
+                      CoreExpr) -- Fail variable applied to realWorld#
 -- See Note [Failure thunks and CPR]
 mkFailurePair expr
   = do { fail_fun_var <- newFailLocalDs (realWorldStatePrimTy `mkFunTy` ty)
@@ -763,7 +757,7 @@ mkOptTickBox (Just tickish) e = Tick tickish e
 
 mkBinaryTickBox :: Int -> Int -> CoreExpr -> DsM CoreExpr
 mkBinaryTickBox ixT ixF e = do
-       uq <- newUnique 	
+       uq <- newUnique  
        this_mod <- getModule
        let bndr1 = mkSysLocal (fsLit "t1") uq boolTy
        let
